/* $Id: getfile.c,v 1.1 1993/10/25 22:35:39 cwikla Exp $ */

/*
**
** Copyright (c) 1993 by Wolfram Research, Inc.  All Rights Reserved.
** 
** WOLFRAM RESEARCH, INC. ("WRI") DOES NOT WARRANT THAT THE SOFTWARE CONTAINED IN
** THIS FILE IS FREE FROM BUGS AND OMISSIONS; THE SOFTWARE IS PROVIDED AS IS.
** WRI MAKES NO REPRESENTATIONS, EXPRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE,
** INCLUDING WITHOUT LIMITATIONS ANY IMPLIED WARRANTIES OF MERCHANTABILITY OR
** FITNESS FOR A PARTICULAR PURPOSE, ALL OF WHICH IS EXPRESSLY DISCLAIMED.  WRI
** DOES NOT WARRANT THAT THE SOFTWARE WILL MEET YOUR REQUIREMENTS OR THAT ITS
** OPERATION WILL BE UNINTERRUPTED OR ERROR FREE.
** 
** WRI DOES NOT WARRANT THAT THE SOFTWARE CONTAINED IN THIS FILE DOES NOT
** INFRINGE UPON THE INTELLECTUAL PROPERTY RIGHTS OF ANY THIRD PARTIES.
** 
** USE OF THE SOFTWARE CONTAINED IN THIS FILE IS ENTIRELY AT YOUR OWN RISK.
** 
** To the extent that it is authorized to do so, Wolfram Research grants the
** recipient of this software permission to use the software for his/her own
** personal purposes subject the user's acceptance of the terms stated above
** and the user's inclusion of Wolfram Reseach's copyright notice and disclaimers
** in any reproduction and/or derivative of this file.  
** 
**
**
**	John L. Cwikla
**	cwikla@wri.com
** 	Wolfram Research, Inc
*/

#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <Xm/FileSB.h>

#include "getfile.h"

static Widget TheFSB = NULL;
static Widget TheShell = NULL;
static char *FileName = NULL;

static int Done = FALSE;

static void buttonCB(Widget w, XtPointer call, XmFileSelectionBoxCallbackStruct *_fsbc)
{
	switch(_fsbc->reason)
	{
		case XmCR_OK:
			if (FileName)
			{
				XtFree(FileName);
				FileName = NULL;
			}
			XmStringGetLtoR(_fsbc->value, XmSTRING_DEFAULT_CHARSET, &FileName);
			if (FileName != NULL)
				Done = TRUE;
			else
				FileName = NULL;
			break;
		case XmCR_CANCEL:
			FileName = NULL;
			Done = TRUE;
			break;
	}
}

static void createFSB(Widget parent)
{
	TheShell = XtCreatePopupShell("File Selector", transientShellWidgetClass, parent, NULL, 0);
	TheFSB = XtCreateManagedWidget("File Selector", xmFileSelectionBoxWidgetClass, TheShell, NULL, 0);

	XtUnmanageChild(XmFileSelectionBoxGetChild(TheFSB, XmDIALOG_HELP_BUTTON));

	XtAddCallback(TheFSB, XmNokCallback, (XtCallbackProc)buttonCB, NULL);
	XtAddCallback(TheFSB, XmNcancelCallback, (XtCallbackProc)buttonCB, NULL);
}


char *GetAFileName(Widget parent)
{
	XEvent event;
	XtAppContext app;

	if (TheFSB == (Widget)NULL)
		createFSB(parent);

	app = XtWidgetToApplicationContext(parent);

	XtPopup(TheShell, XtGrabExclusive);

	Done = FALSE;

	while(!Done)
	{
		XtAppNextEvent(app, &event);
		XtDispatchEvent(&event);
	}

	XtPopdown(TheShell);

	return FileName;
}
